"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ts = require("typescript");
var A = require("./ast");
exports.ast = function (ast) {
    var printer = ts.createPrinter({
        newLine: ts.NewLineKind.LineFeed
    });
    var source = ts.createSourceFile('', '', ts.ScriptTarget.Latest);
    return printer.printNode(ts.EmitHint.Unspecified, ast, source);
};
exports.data = function (d) {
    return A.data(d).map(exports.ast);
};
exports.constructors = function (d) {
    return A.constructors(d).map(function (nodes) { return nodes.map(exports.ast); });
};
exports.fold = function (d) {
    return A.fold(d).map(function (functionDeclarations) { return functionDeclarations.map(exports.ast); });
};
exports.print = function (d, options) {
    if (options === void 0) { options = A.defaultOptions; }
    var dataCode = exports.data(d).run(options);
    var constructorsCode = exports.constructors(d).run(options);
    var foldCode = exports.fold(d).run(options);
    return [dataCode].concat(constructorsCode, foldCode).join('\n\n');
};
